import processing.video.*;

Capture video;

PGraphics Zeichne;
color trackColor; //Farbe nach der wir suchen wollen, nennen wir TrackColor
int xprev=width/2,yprev=height/2;


void setup() {
  size(640,480);
  video = new Capture(this,width,height); //Aufnahme der Webcam wird zu einer Variablen
  trackColor = color(255,0,0); //Wir suchen einfach mal nach Rot zu Beginn 
  smooth(); //sorgt für ein flüssigeres Bild 
  video.start(); //Starte das Video;
  Zeichne = createGraphics(width, height, g.getClass().getName()); 

}

void draw() {
  if (video.available()) {
    video.read();   //wenn das Video verfügbar, dann lies Variable ein 
  }
  video.loadPixels();
  image(video, 0, 0); 
  float maxWert = 500; //
  int closestX = 0; //X,Y Koordinaten der Farbe die am Nächsten liegt 
  int closestY = 0;

  for (int x = 0; x < video.width; x ++ ) { //Damit beginnen wir Pixel für Pixel nach unserer gesuchten Farbe Abzusuchen
    for (int y = 0; y < video.height; y ++ ) {
      int loc = x + y*video.width; //Diese Variable speichert die aktuelle Farbe 
      color currentColor = video.pixels[loc];
      float r1 = red(currentColor);
      float g1 = green(currentColor);
      float b1 = blue(currentColor);
      float r2 = red(trackColor);
      float g2 = green(trackColor);
      float b2 = blue(trackColor);

     
      float z = dist(r1,g1,b1,r2,g2,b2); // Wir benutzen die dist( ) Funktion um die aktuelle Farbe mit unserer gesuchten zu vergleichen

      
      if (z < maxWert) { //Wenn die gefunde Farbe nahe unserer gesuchten Farbe ist, speichern wir sie ein 
        maxWert= z;
        closestX = x;
        closestY = y;
      }
    }
  }
  Zeichne.beginDraw(); //Starte mit dem Zeichnen 
  Zeichne.stroke(trackColor);
  if (maxWert < 25) { //Abweichung des Farbwerts soll weniger als <25 betragen 
   Zeichne.strokeWeight(3);  //Dicke der Linie 
    Zeichne.line(xprev,yprev,closestX, closestY);  //Zeichne einen Punkt auf der Getrackten Farbe, daraus entsteht dann eine Linie 
    xprev = closestX;
    yprev = closestY;
    }
  Zeichne.endDraw();
  image(Zeichne,0,0);
  println("x :"+xprev+"\t y: "+yprev); //Gibt die Aktuelle Position der gefundenen Farbe aus
}



void mousePressed() {
  int loc = mouseX + mouseY*video.width; //Die Farbe die wir suchen wollen lässt sich durch ein simples Anklicken mit der Maus wählen 
  trackColor = video.pixels[loc];
}
