
import processing.serial.*;   //verwende die 'Serial' Library
 
Serial myPort;   // Deklariere ein Object vom Typ 'Serial', mit dem Namen 'myPort'
 
void setup() {
  // Um den Namen der Schnittstelle herauszufinden, lassen wir uns von der Serial-Klasse zunächst
  // eine Liste der Namen der am PC vorhandenen Ports geben ('Serial.list()')
  // Den x'ten Eintrag aus dieser Liste bekommen wir mit 'Serial.list()[x-1]' (die indices fangen mit 0 an)
  // Bei den meisten PCs ist der Arduino der letzte Port in der Liste.
  // Deshalb ermitteln wir zunächst die Länge der Liste (Serial.list().length) 
  // und nehmen uns den letzten Namen aus der Liste heraus (Serial.list()[Serial.list().length-1]) 
  
  String portName = Serial.list()[Serial.list().length-1]; // finde den Namen des letzten Serialports heraus.
  int baudrate=115200;       // Diese Baudrate muss mit der in eurem Arduinoprogramm übereinstimmen.
  myPort = new Serial(this, portName, baudrate); // Erzeuge ein Serial Objekt und stelle eine Verbindung her
 
  size(800, 800); // mache das Fenster etwas größer
}
 
void draw() {
  line(400, 0, 400, 800);
  line(0, 400, 800, 400); //Zeichnet 2 Linien, die sich in der Mitte kreuzen, Mitte entspricht den Werten (124,124), für diese Werte bewegt sich der Copter in keine Himmelsrichtung
  int frontSpeed= (int)map(mouseY, height, 0 ,0, 255 ); //rechne die y-Position des Mauszeigers in einen Schubwert zwischen 0 und 255 um.
  // das (int) sorgt für die Umwandlung der Kommazahl in einen Ganzzahligen (integer) Wert.
  int rightSpeed= (int) map(mouseX, height, 0, 0, 255);   //rechne die x-Position des Mauszeigers in einen Schubwert zwischen 0 und 255 um.
  myPort.write('l'+str(frontSpeed)+"\n");  //Sende erst 'l', dann die mit str() in eine Zeichenkette umgewandelte Zahl, dann einen Zeilenabschluss ("\n")
  myPort.write('r'+str(rightSpeed)+"\n"); //Sende erst 'r', dann die mit str() in eine Zeichenkette umgewandelte Zahl, dann einen Zeilenabschluss ("\n")
  println("x :"+frontSpeed+"\t y: "+rightSpeed); //Gibt die x,y-Koordinaten der Mausposition aus.
}
