import diewald_PS3.PS3;
import diewald_PS3.constants.*;
import diewald_PS3.logger.PS3Logger;


PS3 ps3;
PImage img;

int size_x = 640;
int size_y = 480;
PGraphics topLayer;
color trackColor;
int xprev=width/2,yprev=height/2;

public void setup() {
  PS3Logger.TYPE.DEBUG  .active(true);
  PS3Logger.TYPE.ERROR  .active(true);
  PS3Logger.TYPE.INFO   .active(true);
  PS3Logger.TYPE.WARNING.active(true);

  size(size_x, size_y);

  println("PS3.getCameraCount() = " + PS3.getCameraCount());

  ps3 = PS3.create( 0 );
  ps3.init(VIDEO_MODE.VGA, COLOR_MODE.COLOR_PROCESSED, 30);
  ps3.start();
  ps3.setLed(true);
  img = createImage(ps3.getWidth(), ps3.getHeight(), ARGB);
  trackColor = color(255, 0, 0);
topLayer = createGraphics(width, height, g.getClass().getName());
}

public void draw() {
  assignPixels(ps3, img);
  image(img, 0, 0);

//img.loadPixels();
//image(img, 0, 0);
float worldRecord = 500;
int closestX = 0;
int closestY = 0;
for (int x = 0; x < img.width; x ++ ) {
for (int y = 0; y < img.height; y ++ ) {
int loc = x + y*img.width;
color currentColor = img.pixels[loc];
float r1 = red(currentColor);
float g1 = green(currentColor);
float b1 = blue(currentColor);
float r2 = red(trackColor);
float g2 = green(trackColor);
float b2 = blue(trackColor);
float d = dist(r1, g1, b1, r2, g2, b2);
if (d < worldRecord) {
worldRecord = d;
closestX = x;
closestY = y;
}
}
}
topLayer.beginDraw();
topLayer.stroke(trackColor);
if (worldRecord < 10) {
topLayer.strokeWeight(3);
topLayer.line(xprev,yprev,closestX, closestY);
xprev = closestX;
yprev = closestY;
}
topLayer.endDraw();
image(topLayer,0,0);
  println("x :"+xprev+"\t y: "+yprev); //Gibt die Aktuelle Position der gefundenen Farbe aus

}


public void assignPixels(PS3 ps3, PImage img) {
  img.loadPixels();
  ps3.getFrame(img.pixels);
  img.updatePixels();
}


public void dispose() {
  PS3.shutDown();
}

void mousePressed() {
int loc = mouseX + mouseY*img.width;
trackColor = img.pixels[loc];
}
